//

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.zip.*;

public class Scribble 
extends JFrame  
implements WindowListener{
    
    //variablen
    ScribblePane kritzelFlaeche;

    //implementieren des WindowListener interfaces
    
    public void windowClosing(WindowEvent e) {
        dispose();
        System.exit(0);
    }

    public void windowClosed(WindowEvent e) {
    }
    
    public void windowOpened(WindowEvent e) {
    }

    public void windowIconified(WindowEvent e) {
    }

    public void windowDeiconified(WindowEvent e) {
    }

    public void windowActivated(WindowEvent e) {
    }

    public void windowDeactivated(WindowEvent e) {
    }
    
    //der konstruktor von Scribble
    public Scribble() {
       super ("Scribble"); //dies ruft den konstruktor der elternklasse auf 
                           //und "ubergibt diesem den fenstertitel
    
       this.addWindowListener(this);
       
       //ermitteln der contentPane und festlegen des layout-managers
       Container contentPane = this.getContentPane();
       contentPane.setLayout(new BorderLayout());
       
       //neues ScribblePane-objekt erzeugen, hintergrundfarbe und rand
       //setzen und in die contentPane einf"ugen
       kritzelFlaeche = new ScribblePane();
       kritzelFlaeche.setBorder(new BevelBorder(BevelBorder.LOWERED));
       kritzelFlaeche.setBackground(Color.white);
       contentPane.add(kritzelFlaeche, BorderLayout.CENTER);
       
       //menueleiste erzeugen und zu JFrame hinzuf"ugen
       //menues werden von JFrame besonders behandelt und ausserhalb der
       //contentPane hinzugef"ugt
       JMenuBar menueLeiste = new JMenuBar();
       this.setJMenuBar(menueLeiste);
       
       //menueeintr"age erzeugen
       //dateimenue
       JMenu dateiMenue = new JMenu("Datei");
          //neu
          Action neu = new NeuAction(); //NeuAction ist innere Klasse; s.u.
          dateiMenue.add(neu);
          //ffnen
          Action oeffnen = new OeffnenAction();
          dateiMenue.add(oeffnen);
          //schliessen
          Action schliessen = new SchliessenAction();
          dateiMenue.add(schliessen);
          menueLeiste.add(dateiMenue);
          //speichern
          Action speichern = new SpeichernAction();
          dateiMenue.add(speichern);
       //berarbeitenmenue
       JMenu bearbeitenMenue = new JMenu("Berarbeiten");
          //loeschen
          Action loeschen = new LoeschenAction();
          bearbeitenMenue.add(loeschen);
          //neuzeichnen
          Action neuzeichnen = new NeuzeichnenAction();
          bearbeitenMenue.add(neuzeichnen);
       menueLeiste.add(bearbeitenMenue);
       //farbmenue
       JMenu farbMenue = new JMenu("Farbe");
          //rot
          Action rot = new FarbAction(Color.red, "rot");
          farbMenue.add(rot);
          //blau
          Action blau = new FarbAction(Color.blue, "blau");
          farbMenue.add(blau);
          //gruen
          Action gruen = new FarbAction(Color.green, "gruen");
          farbMenue.add(gruen);
          //schwarz
          Action schwarz = new FarbAction(Color.black, "schwarz");
          farbMenue.add(schwarz);
       menueLeiste.add(farbMenue);
       //werkzeugmenue
       JMenu werkzeugMenue = new JMenu("Werkzeuge");
          //zeiger
          Action zeiger = new WerkzeugAction("Zeiger");
          werkzeugMenue.add(zeiger);
          //rechteck
          Action rechteck = new WerkzeugAction("Rechteck");
          werkzeugMenue.add(rechteck);
          //stift
          Action stift = new WerkzeugAction("Stift");
          werkzeugMenue.add(stift);
          //verschieben
          Action verschieben = new WerkzeugAction("Verschieben");
          werkzeugMenue.add(verschieben);
           //aendern
          Action aendern = new WerkzeugAction("Aendern");
          werkzeugMenue.add(aendern);
       menueLeiste.add(werkzeugMenue);
       
    } //hier endet der konstruktor
    
    //innere klassen
    class NeuAction extends AbstractAction {
        public NeuAction() {
            super("Neu");
        }
        public void actionPerformed(ActionEvent e) {
            System.out.println("menueeintrag neu gecklickt");
        }
        
    }
    
    class OeffnenAction extends AbstractAction {
        public OeffnenAction() {
            super("Oeffnen");
        }
        public void actionPerformed(ActionEvent e) {
            System.out.println("menueeintrag oeffnen gecklickt");
        }
    }
    
    class SchliessenAction extends AbstractAction {
        public SchliessenAction() {
            super("Schliessen");
        }
        public void actionPerformed(ActionEvent e) {
            System.out.println("menueeintrag schliessen geklickt");
            dispose();
            System.exit(0);
        }
    }
    
    class SpeichernAction extends AbstractAction {
         public SpeichernAction() {
            super("Speichern");
        }
        public void actionPerformed(ActionEvent e) {
            System.out.println("menueeintrag speichern geklickt");
            try {
                File pfad = new File("/bird/daten/tmp/mojorisin2");
                System.out.println(pfad);
               // FileOutputStream fos = new FileOutputStream("/bird/daten/tmp/mojorisin");
                 FileOutputStream fos = new FileOutputStream(pfad);
                GZIPOutputStream gzos = new GZIPOutputStream(fos);
                ObjectOutputStream out = new ObjectOutputStream(gzos);
                out.writeObject(kritzelFlaeche.getFormen());
               // out.writeObject("teste");
                out.flush();
                out.close();
            }
            catch(IOException ioe) {
                System.out.println(ioe);
            }
        }
    }
    
    class LoeschenAction extends AbstractAction {
        public LoeschenAction() {
            super("Loeschen");
        }
        public void actionPerformed(ActionEvent e) {
            System.out.println("menueeintrag Loeschen geklickt");
            kritzelFlaeche.repaint();
            kritzelFlaeche.loescheFormen();
        }
    }
    
     class NeuzeichnenAction extends AbstractAction {
        public NeuzeichnenAction() {
            super("Neuzeichnen");
        }
        public void actionPerformed(ActionEvent e) {
            kritzelFlaeche.neuZeichnen();
        }
    }
    
    class FarbAction extends AbstractAction {
        Color farbe;
        //der konstruktor:
        public FarbAction(Color farbePar, String farbOption) {
            super(farbOption);  //der konstruktor der superklasse erhaelt den
            //namen des menueeintrags
            farbe = farbePar;  //setzen der eigenschaft farbe dieser klasse
        }
        public void actionPerformed(ActionEvent e) {
             kritzelFlaeche.setColor(farbe);
        }
    }
    
    class WerkzeugAction extends AbstractAction {
        String werkzeug;
        //der konstruktor
        public WerkzeugAction(String werkzeugPar) {
            super(werkzeugPar);
            werkzeug = werkzeugPar;
        }
        public void actionPerformed(ActionEvent e) {
            kritzelFlaeche.setWerkzeug(werkzeug);
            System.out.println(werkzeug);
        }
    }
    
    
    
    //die main-methode erzeugt ein Scribble-objekt und stellt es dar
    public static void main(String[] args) {
        Scribble kritzel = new Scribble();
        kritzel.setSize(500,300);
        kritzel.setVisible(true);
    }
}
 
   